

#include <ESP8266WiFi.h>
#include <PubSubClient.h>
#include "DHTesp.h"
DHTesp dht;

#define LED D3
#define LED_placa 16

const char* WIFI_SSID = "MOVISTAR_F240";
const char* WIFI_PASSWORD = "onptaqd6WQhFaSE4GhS6";



// MQTT: ID, server IP, port, username and password
const PROGMEM char* MQTT_CLIENT_ID = "usuario_educrea";
const PROGMEM char* MQTT_SERVER_IP = "192.168.1.111";
const PROGMEM uint16_t MQTT_SERVER_PORT = 1883;
const PROGMEM char* MQTT_USER = "mqtt";
const PROGMEM char* MQTT_PASSWORD = "mqtt";



char* deviceId  = "educrea"; // Name of the sensor
char* stateTopic_humedad = "home-assistant/educrea/humedad"; // MQTT topic where values are published
char* stateTopic_suelo = "home-assistant/educrea/suelo";
char* stateTopic_temperatura = "home-assistant/educrea/temperatura";
int sensorPin = A0; // Pin to which the sensor is connected to
char buf[4]; // Buffer to store the sensor value
int updateInterval = 1000; // Interval in milliseconds

#define DHTPIN 2
#define DHTTYPE DHT22

WiFiClient wifiClient;
PubSubClient client(wifiClient);


void reconnect() {
  while (!client.connected()) {
    Serial.println("INFO: Attempting MQTT connection...");
    if (client.connect(MQTT_CLIENT_ID, MQTT_USER, MQTT_PASSWORD)) {
      Serial.println("INFO: connected");
    }
    else {
      Serial.print("ERROR: failed, rc=");
      Serial.print(client.state());
      Serial.println("DEBUG: try again in 5 seconds");
      delay(5000);
    }
  }
  client.subscribe("/educrea/luz");
}

void callback (char* topic, byte* payload, unsigned int length) {
  Serial.print("Mensaje :");
  Serial.println(topic);
  String message;

 
  Serial.print(message);

  for(int i=0; i<length; i++){
    message= message + (char)payload[i];
    }
   
  if (message == "1") {
    digitalWrite(LED, LOW);
    digitalWrite(LED_placa, LOW);
  }
  if (message == "0") {
    digitalWrite(LED, HIGH);
    digitalWrite(LED_placa, HIGH);
  }

  Serial.println(".");


}

void setup() {
  delay(1000);
  Serial.begin(115200);
  
  dht.setup(D2, DHTesp::DHT22);
  pinMode(LED,OUTPUT);
  pinMode(LED_placa,OUTPUT);
  
  
  Serial.println();
  Serial.print("Conectando");
  WiFi.mode(WIFI_STA);
  Serial.println(WIFI_SSID);
  WiFi.begin(WIFI_SSID, WIFI_PASSWORD);

  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }

  Serial.println("");
  Serial.println("WiFi connected");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());

  client.setServer(MQTT_SERVER_IP, MQTT_SERVER_PORT);
  client.setCallback(callback);
}

void loop() {
  if (!client.connected()) {
    reconnect();
  }
  client.loop();
  float h = dht.getHumidity()*10;
  float t = dht.getTemperature()*10;
  int suelo_humedad = analogRead(sensorPin);
#if DEBUG
  Serial.print("Suelo: ");
  Serial.println(suelo_humedad);
  if (isnan(h) || isnan(t)) {
    Serial.println("ERROR: Failed to read from DHT sensor!");
    return;

  } else {
    Serial.print("Temperatura: ");
    Serial.println(t);
    Serial.print("Humedad: ");
    Serial.println(h);
  }
#endif
  client.publish(stateTopic_suelo, itoa(suelo_humedad, buf, 10));
  client.publish(stateTopic_humedad, itoa(h, buf, 10));
  client.publish(stateTopic_temperatura, itoa(t, buf, 10));
  delay(updateInterval);
  
}
